<template lang="pug">
.tooltip
	.tooltip-trigger
		slot( v-if='$slots.default' )
		span.icon.is-small( v-else :class='bindIconClass' )
			i.fa-solid.fa-question-circle
	.tooltip-content( :class='bindClass' )
		slot( v-if='$slots.content' name="content" )
		template( v-else ) {{ content }}
</template>

<script setup>
import { computed } from "vue"

const props = defineProps({
	content: {
		type: String,
		default: ""
	},
	position: {
		type: String,
		default: "",
		validator: val => [ "", "right", "bottom", "left" ].includes(val)
	},
	size: {
		type: String,
		default: "",
		validator: val => [ "", "medium", "large" ].includes(val)
	},
	type: String
})

const bindClass = computed(() => [
	props.position ? `is-${props.position}` : "is-top",
	props.size ? `is-${props.size}` : ""
])
const bindIconClass = computed(() => [
	props.type ? `has-text-${props.type}` : ""
])
</script>

<style lang="scss" scoped>
.tooltip {
	display: inline-block;
	position: relative;
	&-trigger {
		width: 100%;
		height: 100%;
		cursor: pointer;
	}
	&:hover {
		.tooltip-content {
			opacity: 1;
			pointer-events: all;
		}
	}
	&-content {
		font-size: .875rem;
		color: $white!important;
		line-height: 1rem;
		font-weight: 400;
		white-space: nowrap;
		width: auto;
		margin: 0 auto;
		padding: .25rem .5rem;
		background: $tooltip-background;
		border-radius: 4px;
		position: absolute;
		transition: opacity .2s ease-in-out;
		opacity: 0;
		pointer-events: none;
		z-index: 3;

		&.is-medium {
			white-space: normal;
			width: 20rem;
			max-width: unset;
		}

		&.is-large {
			white-space: normal;
			width: 30rem;
			max-width: unset;
		}

		&.is-top,
		&.is-bottom {
			left: 50%;
			transform: translateX(-50%);
			&::before {
				border-left: 5px solid;
				border-right: 5px solid;
				left: 50%;
				transform: translateX(-50%);
			}
		}
		&.is-top {
			bottom: calc(100% + .5rem);
			&::before {
				border-top: 5px solid $tooltip-background;
				top: 100%;
			}
		}
		&.is-bottom {
			top: calc(100% + .5rem);
			&::before {
				border-bottom: 5px solid $tooltip-background;
				bottom: 100%;
			}
		}
		&.is-right,
		&.is-left {
			top: 50%;
			transform: translateY(-50%);
			&::before {
				border-top: 5px solid;
				border-bottom: 5px solid;
				top: 50%;
				transform: translateY(-50%);
			}
		}
		&.is-right {
			left: calc(100% + .5rem);
			&::before {
				border-right: 5px solid $tooltip-background;
				right: 100%;
			}
		}
		&.is-left {
			right: calc(100% + .5rem);
			&::before {
				border-left: 5px solid $tooltip-background;
				left: 100%;
			}
		}
		&::before {
			content: "";
			display: block;
			border-color: transparent;
			position: absolute;
		}
	}
}
</style>

<style lang="scss" scoped>
span + .tooltip {
	margin-left: .25rem;
}
</style>